<template>
<div>
  <v-row>
    <v-col>
      <h1>Éditer le procédé n°{{ process._id }}</h1>
    </v-col>
  </v-row>
  <v-row>
    <v-col>
      <v-form>
        <v-text-field
            label="Nom"
            outlined
            v-model="process.name"
            required
        ></v-text-field>

        <v-textarea
            label="Description"
            outlined
            v-model="process.description"
            required
        ></v-textarea>

        <v-select
            v-model="process.design"
            :items="designs"
            label="Modèle"
            outlined
            required
        ></v-select>

        <v-textarea
            label="Protocole"
            outlined
            v-model="process.protocol"
            required
        ></v-textarea>

        <v-btn @click="submit" :disabled="disabled">Éditer</v-btn>
        <v-btn to="/">Annuler</v-btn>
      </v-form>
    </v-col>
  </v-row>
</div>
</template>

<script>
import Vue from 'vue'

export default Vue.extend({
  data() {
    return {
      process: {
          _id: null,
          name: null,
          description: null,
          design: null,
          protocol: null,
      },
      designs: [],
    }
  },
  computed: {
    disabled() {
        return !(
          this.process.name
          && this.process.description
          && this.process.design
          && this.process.protocol
        );
    }
  },
  methods: {
    submit() {
      // const token = document.cookie
      //   .split('; ')
      //   .find(row => row.startsWith('token='))
      //   .split('=')[1];
      // this.$axios.setToken(token, 'Bearer')

      this.$axios.put('/processes' + this.process._id, this.process)
        .then(res => {
          if (res.status === 200) {
            this.$router.push('/');
          } else {
            console.log(res);
          }
        })
        .catch(err => {
          console.log(err);
        })
    }
  },
  mounted() {
    // const token = document.cookie
    //   .split('; ')
    //   .find(row => row.startsWith('token='))
    //   .split('=')[1];
    // this.$axios.setToken(token, 'Bearer')

    this.$axios.get('/processes/' + this.$route.query.id)
      .then(res => {
        if (res.status === 200) {
          this.process = res.data === null ? [] : res.data;
        } else {
          console.log(res);
        }
      })
      .catch(err => {
        console.log(err);
      })

    this.$axios.get('/designs')
      .then(res => {
        if (res.status === 200) {
          this.designs = res.data === null ? [] : res.data;
        } else {
          console.log(res);
        }
      })
      .catch(err => {
        console.log(err);
      })
  }
})
</script>
